diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/interference-helper.h ns-3.34/src/wifi/model/interference-helper.h
--- ns-3.33/src/wifi/model/interference-helper.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wifi/model/interference-helper.h	2021-07-14 10:31:07.000000000 -0700
@@ -21,10 +21,7 @@
 #ifndef INTERFERENCE_HELPER_H
 #define INTERFERENCE_HELPER_H
 
-#include "ns3/nstime.h"
-#include "ns3/wifi-spectrum-value-helper.h"
-#include "wifi-tx-vector.h"
-#include <map>
+#include "phy-entity.h"
 
 namespace ns3 {
 
@@ -33,11 +30,6 @@
 class ErrorRateModel;
 
 /**
- * A map of the received power (Watts) for each band
- */
-typedef std::map <WifiSpectrumBand, double> RxPowerWattPerChannelBand;
-
-/**
  * \ingroup wifi
  * \brief handles interference calculations
  * \brief signal event for a PPDU.
@@ -53,7 +45,7 @@
    * \param duration duration of the PPDU
    * \param rxPower the received power per band (W)
    */
-  Event (Ptr<const WifiPpdu> ppdu, WifiTxVector txVector, Time duration, RxPowerWattPerChannelBand rxPower);
+  Event (Ptr<const WifiPpdu> ppdu, const WifiTxVector& txVector, Time duration, RxPowerWattPerChannelBand rxPower);
   ~Event ();
 
   /**
@@ -104,7 +96,14 @@
    *
    * \return the TXVECTOR of the PPDU
    */
-  WifiTxVector GetTxVector (void) const;
+  const WifiTxVector& GetTxVector (void) const;
+  /**
+   * Update the received power (W) for all bands, i.e. add up the received power
+   * to the current received power, for each band.
+   *
+   * \param rxPower the received power (W) for all bands.
+   */
+  void UpdateRxPowerW (RxPowerWattPerChannelBand rxPower);
 
 
 private:
@@ -132,19 +131,6 @@
 class InterferenceHelper
 {
 public:
-  /**
-   * Signal event for a PPDU.
-   */
-
-  /**
-   * A struct for both SNR and PER
-   */
-  struct SnrPer
-  {
-    double snr; ///< SNR in linear scale
-    double per; ///< PER
-  };
-
   InterferenceHelper ();
   ~InterferenceHelper ();
 
@@ -195,7 +181,7 @@
    *          energy on the medium for a given band will
    *          be higher than the requested threshold.
    */
-  Time GetEnergyDuration (double energyW, WifiSpectrumBand band) const;
+  Time GetEnergyDuration (double energyW, WifiSpectrumBand band);
 
   /**
    * Add the PPDU-related signal to interference helper.
@@ -204,10 +190,11 @@
    * \param txVector the TXVECTOR
    * \param duration the PPDU duration
    * \param rxPower received power per band (W)
+   * \param isStartOfdmaRxing flag whether the event corresponds to the start of the OFDMA payload reception (only used for UL-OFDMA) //TODO simplify this once WifiPpdu is subclassed by adding an attribute
    *
    * \return Event
    */
-  Ptr<Event> Add (Ptr<const WifiPpdu> ppdu, WifiTxVector txVector, Time duration, RxPowerWattPerChannelBand rxPower);
+  Ptr<Event> Add (Ptr<const WifiPpdu> ppdu, const WifiTxVector& txVector, Time duration, RxPowerWattPerChannelBand rxPower, bool isStartOfdmaRxing = false);
 
   /**
    * Add a non-Wifi signal to interference helper.
@@ -230,7 +217,7 @@
    *
    * \return struct of SNR and PER (with PER being evaluated over the provided time window)
    */
-  struct InterferenceHelper::SnrPer CalculatePayloadSnrPer (Ptr<Event> event, uint16_t channelWidth, WifiSpectrumBand band,
+  struct PhyEntity::SnrPer CalculatePayloadSnrPer (Ptr<Event> event, uint16_t channelWidth, WifiSpectrumBand band,
                                                             uint16_t staId, std::pair<Time, Time> relativeMpduStartStop) const;
   /**
    * Calculate the SNIR for the event (starting from now until the event end).
@@ -244,25 +231,18 @@
    */
   double CalculateSnr (Ptr<Event> event, uint16_t channelWidth, uint8_t nss, WifiSpectrumBand band) const;
   /**
-   * Calculate the SNIR at the start of the non-HT PHY header and accumulate
-   * all SNIR changes in the SNIR vector.
-   *
-   * \param event the event corresponding to the first time the corresponding PPDU arrives
-   * \param band identify the band used by the PSDU
-   *
-   * \return struct of SNR and PER
-   */
-  struct InterferenceHelper::SnrPer CalculateNonHtPhyHeaderSnrPer (Ptr<Event> event, WifiSpectrumBand band) const;
-  /**
-   * Calculate the SNIR at the start of the HT PHY header and accumulate
+   * Calculate the SNIR at the start of the PHY header and accumulate
    * all SNIR changes in the SNIR vector.
    *
    * \param event the event corresponding to the first time the corresponding PPDU arrives
+   * \param channelWidth the channel width (in MHz) for header measurement
    * \param band identify the band used by the PSDU
+   * \param header the PHY header to consider
    *
    * \return struct of SNR and PER
    */
-  struct InterferenceHelper::SnrPer CalculateHtPhyHeaderSnrPer (Ptr<Event> event, WifiSpectrumBand band) const;
+  struct PhyEntity::SnrPer CalculatePhyHeaderSnrPer (Ptr<Event> event, uint16_t channelWidth, WifiSpectrumBand band,
+                                                              WifiPpduField header) const;
 
   /**
    * Notify that RX has started.
@@ -270,13 +250,23 @@
   void NotifyRxStart ();
   /**
    * Notify that RX has ended.
+   * 
+   * \param endTime the end time of the signal
    */
-  void NotifyRxEnd ();
+  void NotifyRxEnd (Time endTime);
   /**
    * Erase all events.
    */
   void EraseEvents (void);
 
+  /**
+   * Update event to scale its received power (W) per band.
+   *
+   * \param event the event to be updated
+   * \param rxPower the received power (W) per band to be added to the current event
+   */
+  void UpdateEvent (Ptr<Event> event, RxPowerWattPerChannelBand rxPower);
+
 
 protected:
   /**
@@ -291,18 +281,30 @@
    */
   double CalculateSnr (double signal, double noiseInterference, uint16_t channelWidth, uint8_t nss) const;
   /**
-   * Calculate the success rate of the chunk given the SINR, duration, and Wi-Fi mode.
-   * The duration and mode are used to calculate how many bits are present in the chunk.
+   * Calculate the success rate of the chunk given the SINR, duration, and TXVECTOR.
+   * The duration and TXVECTOR are used to calculate how many bits are present in the chunk.
    *
    * \param snir the SINR
    * \param duration the duration of the chunk
    * \param mode the WifiMode
    * \param txVector the TXVECTOR
+   * \param field the PPDU field to which the chunk belongs to
    *
    * \return the success rate
    */
-  double CalculateChunkSuccessRate (double snir, Time duration, WifiMode mode, WifiTxVector txVector) const;
-
+  double CalculateChunkSuccessRate (double snir, Time duration, WifiMode mode, const WifiTxVector& txVector, WifiPpduField field) const;
+  /**
+   * Calculate the success rate of the payload chunk given the SINR, duration, and TXVECTOR.
+   * The duration and TXVECTOR are used to calculate how many bits are present in the payload chunk.
+   *
+   * \param snir the SINR
+   * \param duration the duration of the chunk
+   * \param txVector the TXVECTOR
+   * \param staId the station ID of the PSDU (only used for MU)
+   *
+   * \return the success rate
+   */
+  double CalculatePayloadChunkSuccessRate (double snir, Time duration, const WifiTxVector& txVector, uint16_t staId = SU_STA_ID) const;
 
 private:
   /**
@@ -318,6 +320,7 @@
      * \param event causes this NI change
      */
     NiChange (double power, Ptr<Event> event);
+    ~NiChange ();
     /**
      * Return the power
      *
@@ -356,9 +359,11 @@
   /**
    * Append the given Event.
    *
-   * \param event
+   * \param event the event to be appended
+   * \param isStartOfdmaRxing flag whether event corresponds to the start of the OFDMA payload reception (only used for UL-OFDMA)
    */
-  void AppendEvent (Ptr<Event> event);
+  void AppendEvent (Ptr<Event> event, bool isStartOfdmaRxing);
+
   /**
    * Calculate noise and interference power in W.
    *
@@ -370,18 +375,6 @@
    */
   double CalculateNoiseInterferenceW (Ptr<Event> event, NiChangesPerBand *nis, WifiSpectrumBand band) const;
   /**
-   * Calculate the success rate of the payload chunk given the SINR, duration, and Wi-Fi mode.
-   * The duration and mode are used to calculate how many bits are present in the chunk.
-   *
-   * \param snir the SINR
-   * \param duration the duration of the chunk
-   * \param txVector the TXVECTOR
-   * \param staId the station ID of the PSDU (only used for MU)
-   *
-   * \return the success rate
-   */
-  double CalculatePayloadChunkSuccessRate (double snir, Time duration, WifiTxVector txVector, uint16_t staId) const;
-  /**
    * Calculate the error rate of the given PHY payload only in the provided time
    * window (thus enabling per MPDU PER information). The PHY payload can be divided into
    * multiple chunks (e.g. due to interference from other transmissions).
@@ -398,27 +391,34 @@
   double CalculatePayloadPer (Ptr<const Event> event, uint16_t channelWidth, NiChangesPerBand *nis, WifiSpectrumBand band,
                               uint16_t staId, std::pair<Time, Time> window) const;
   /**
-   * Calculate the error rate of the non-HT PHY header. The non-HT PHY header
+   * Calculate the error rate of the PHY header. The PHY header
    * can be divided into multiple chunks (e.g. due to interference from other transmissions).
    *
    * \param event the event
    * \param nis the NiChanges
+   * \param channelWidth the channel width (in MHz) for header measurement
    * \param band the band
+   * \param header the PHY header to consider
    *
-   * \return the error rate of the non-HT PHY header
+   * \return the error rate of the HT PHY header
    */
-  double CalculateNonHtPhyHeaderPer (Ptr<const Event> event, NiChangesPerBand *nis, WifiSpectrumBand band) const;
+  double CalculatePhyHeaderPer (Ptr<const Event> event, NiChangesPerBand *nis,
+                                uint16_t channelWidth, WifiSpectrumBand band,
+                                WifiPpduField header) const;
   /**
-   * Calculate the error rate of the HT PHY header. TheHT PHY header
-   * can be divided into multiple chunks (e.g. due to interference from other transmissions).
+   * Calculate the success rate of the PHY header sections for the provided event.
    *
    * \param event the event
    * \param nis the NiChanges
+   * \param channelWidth the channel width (in MHz) for header measurement
    * \param band the band
+   * \param phyHeaderSections the map of PHY header sections (\see PhyEntity::PhyHeaderSections)
    *
-   * \return the error rate of the HT PHY header
+   * \return the success rate of the PHY header sections
    */
-  double CalculateHtPhyHeaderPer (Ptr<const Event> event, NiChangesPerBand *nis, WifiSpectrumBand band) const;
+  double CalculatePhyHeaderSectionPsr (Ptr<const Event> event, NiChangesPerBand *nis,
+                                       uint16_t channelWidth, WifiSpectrumBand band,
+                                       PhyEntity::PhyHeaderSections phyHeaderSections) const;
 
   double m_noiseFigure;                                    //!< noise figure (linear)
   Ptr<ErrorRateModel> m_errorRateModel;                    //!< error rate model
@@ -434,7 +434,7 @@
    * \param band identify the band to check
    * \returns an iterator to the list of NiChanges
    */
-  NiChanges::const_iterator GetNextPosition (Time moment, WifiSpectrumBand band) const;
+  NiChanges::iterator GetNextPosition (Time moment, WifiSpectrumBand band);
   /**
    * Returns an iterator to the last NiChange that is before than moment
    *
@@ -442,7 +442,7 @@
    * \param band identify the band to check
    * \returns an iterator to the list of NiChanges
    */
-  NiChanges::const_iterator GetPreviousPosition (Time moment, WifiSpectrumBand band) const;
+  NiChanges::iterator GetPreviousPosition (Time moment, WifiSpectrumBand band);
 
   /**
    * Add NiChange to the list at the appropriate position and
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/mac-rx-middle.cc ns-3.34/src/wifi/model/mac-rx-middle.cc
--- ns-3.33/src/wifi/model/mac-rx-middle.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wifi/model/mac-rx-middle.cc	2021-07-14 10:31:07.000000000 -0700
@@ -301,10 +301,7 @@
   NS_LOG_FUNCTION (*mpdu);
   const WifiMacHeader* hdr = &mpdu->GetHeader ();
   NS_ASSERT (hdr->IsData () || hdr->IsMgt ());
-  if (!m_pcfCallback.IsNull ())
-    {
-      m_pcfCallback ();
-    }
+
   OriginatorRxStatus *originator = Lookup (hdr);
   /**
    * The check below is really unneeded because it can fail in a lot of
@@ -354,10 +351,4 @@
     }
 }
 
-void
-MacRxMiddle::SetPcfCallback (Callback<void> callback)
-{
-  m_pcfCallback = callback;
-}
-
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/mac-rx-middle.h ns-3.34/src/wifi/model/mac-rx-middle.h
--- ns-3.33/src/wifi/model/mac-rx-middle.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wifi/model/mac-rx-middle.h	2021-07-14 10:31:07.000000000 -0700
@@ -57,13 +57,6 @@
   void SetForwardCallback (ForwardUpCallback callback);
 
   /**
-   * Set a callback to trigger the next PCF frame.
-   *
-   * \param callback the callback to set
-   */
-  void SetPcfCallback (Callback<void> callback);
-
-  /**
    * Receive a packet.
    *
    * \param mpdu the MPDU
@@ -133,8 +126,6 @@
   Originators m_originatorStatus; ///< originator status
   QosOriginators m_qosOriginatorStatus; ///< QOS originator status
   ForwardUpCallback m_callback; ///< forward up callback
-
-  Callback<void> m_pcfCallback; //!< PCF callback
 };
 
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/mac-tx-middle.cc ns-3.34/src/wifi/model/mac-tx-middle.cc
--- ns-3.33/src/wifi/model/mac-tx-middle.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wifi/model/mac-tx-middle.cc	2021-07-14 10:31:07.000000000 -0700
@@ -124,4 +124,24 @@
   return seq;
 }
 
+void
+MacTxMiddle::SetSequenceNumberFor (const WifiMacHeader *hdr)
+{
+  NS_LOG_FUNCTION (this << *hdr);
+
+  if (hdr->IsQosData ()
+      && !hdr->GetAddr1 ().IsGroup ())
+    {
+      uint8_t tid = hdr->GetQosTid ();
+      NS_ASSERT (tid < 16);
+      auto it = m_qosSequences.find (hdr->GetAddr1 ());
+      NS_ASSERT (it != m_qosSequences.end ());
+      it->second[tid] = hdr->GetSequenceNumber ();
+    }
+  else
+    {
+      m_sequence = hdr->GetSequenceNumber ();
+    }
+}
+
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/mac-tx-middle.h ns-3.34/src/wifi/model/mac-tx-middle.h
--- ns-3.33/src/wifi/model/mac-tx-middle.h	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/mac-tx-middle.h	2021-07-14 10:31:07.000000000 -0700
@@ -65,7 +65,13 @@
    * \return the next sequence number
    */
   uint16_t GetNextSeqNumberByTidAndAddress (uint8_t tid, Mac48Address addr) const;
-
+  /**
+   * Set the sequence number of the given MAC header as the next sequence
+   * number for the Traffic ID and destination of the given MAC header.
+   *
+   * \param hdr the given MAC header
+   */
+  void SetSequenceNumberFor (const WifiMacHeader *hdr);
 
 private:
   std::map <Mac48Address,uint16_t*> m_qosSequences; ///< QOS sequences
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/mgt-headers.cc ns-3.34/src/wifi/model/mgt-headers.cc
--- ns-3.33/src/wifi/model/mgt-headers.cc	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/mgt-headers.cc	2021-07-14 10:31:07.000000000 -0700
@@ -313,18 +313,6 @@
 }
 
 void
-MgtProbeResponseHeader::SetCfParameterSet (CfParameterSet cfParameterSet)
-{
-  m_cfParameterSet = cfParameterSet;
-}
-
-CfParameterSet
-MgtProbeResponseHeader::GetCfParameterSet (void) const
-{
-  return m_cfParameterSet;
-}
-
-void
 MgtProbeResponseHeader::SetSsid (Ssid ssid)
 {
   m_ssid = ssid;
@@ -404,7 +392,6 @@
   size += m_capability.GetSerializedSize ();
   size += m_ssid.GetSerializedSize ();
   size += m_rates.GetSerializedSize ();
-  size += m_cfParameterSet.GetSerializedSize ();
   size += m_dsssParameterSet.GetSerializedSize ();
   size += m_erpInformation.GetSerializedSize ();
   size += m_rates.extended.GetSerializedSize ();
@@ -452,7 +439,6 @@
   i = m_capability.Serialize (i);
   i = m_ssid.Serialize (i);
   i = m_rates.Serialize (i);
-  i = m_cfParameterSet.Serialize (i);
   i = m_dsssParameterSet.Serialize (i);
   i = m_erpInformation.Serialize (i);
   i = m_rates.extended.Serialize (i);
@@ -476,7 +462,6 @@
   i = m_capability.Deserialize (i);
   i = m_ssid.Deserialize (i);
   i = m_rates.Deserialize (i);
-  i = m_cfParameterSet.DeserializeIfPresent (i);
   i = m_dsssParameterSet.DeserializeIfPresent (i);
   i = m_erpInformation.DeserializeIfPresent (i);
   i = m_rates.extended.DeserializeIfPresent (i);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/mgt-headers.h ns-3.34/src/wifi/model/mgt-headers.h
--- ns-3.33/src/wifi/model/mgt-headers.h	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/mgt-headers.h	2021-07-14 10:31:07.000000000 -0700
@@ -28,17 +28,16 @@
 #include "capability-information.h"
 #include "supported-rates.h"
 #include "ssid.h"
-#include "dsss-parameter-set.h"
+#include "ns3/dsss-parameter-set.h"
 #include "extended-capabilities.h"
-#include "ht-capabilities.h"
-#include "ht-operation.h"
-#include "vht-capabilities.h"
-#include "vht-operation.h"
-#include "erp-information.h"
+#include "ns3/ht-capabilities.h"
+#include "ns3/ht-operation.h"
+#include "ns3/vht-capabilities.h"
+#include "ns3/vht-operation.h"
+#include "ns3/erp-information.h"
 #include "edca-parameter-set.h"
-#include "he-capabilities.h"
-#include "he-operation.h"
-#include "cf-parameter-set.h"
+#include "ns3/he-capabilities.h"
+#include "ns3/he-operation.h"
 
 namespace ns3 {
 
@@ -154,11 +153,12 @@
    * \return The TypeId.
    */
   static TypeId GetTypeId (void);
-  TypeId GetInstanceTypeId (void) const;
-  void Print (std::ostream &os) const;
-  uint32_t GetSerializedSize (void) const;
-  void Serialize (Buffer::Iterator start) const;
-  uint32_t Deserialize (Buffer::Iterator start);
+
+  TypeId GetInstanceTypeId (void) const override;
+  void Print (std::ostream &os) const override;
+  uint32_t GetSerializedSize (void) const override;
+  void Serialize (Buffer::Iterator start) const override;
+  uint32_t Deserialize (Buffer::Iterator start) override;
 
 
 private:
@@ -706,12 +706,6 @@
    */
   EdcaParameterSet GetEdcaParameterSet (void) const;
   /**
-   * Return the CF parameter set.
-   *
-   * \return CF parameter set
-   */
-  CfParameterSet GetCfParameterSet (void) const;
-  /**
    * Set the Capability information.
    *
    * \param capabilities Capability information
@@ -796,12 +790,6 @@
    */
   void SetEdcaParameterSet (EdcaParameterSet edcaParameterSet);
   /**
-   * Set the CF parameter set.
-   *
-   * \param cfParameterSet CF parameter set
-   */
-  void SetCfParameterSet (CfParameterSet cfParameterSet);
-  /**
    * Return the time stamp.
    *
    * \return time stamp
@@ -836,7 +824,6 @@
   HeOperation m_heOperation;         //!< HE operation
   ErpInformation m_erpInformation;     //!< ERP information
   EdcaParameterSet m_edcaParameterSet; //!< EDCA Parameter Set
-  CfParameterSet m_cfParameterSet;     //!< CF parameter set
 };
 
 
@@ -1263,7 +1250,7 @@
    * \return The TypeId.
    */
   static TypeId GetTypeId (void);
-  // Inherited
+
   TypeId GetInstanceTypeId (void) const;
   void Print (std::ostream &os) const;
   uint32_t GetSerializedSize (void) const;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/mpdu-aggregator.cc ns-3.34/src/wifi/model/mpdu-aggregator.cc
--- ns-3.33/src/wifi/model/mpdu-aggregator.cc	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/mpdu-aggregator.cc	2021-07-14 10:31:07.000000000 -0700
@@ -26,17 +26,17 @@
 #include "wifi-phy.h"
 #include "wifi-tx-vector.h"
 #include "wifi-remote-station-manager.h"
-#include "mac-low.h"
 #include "wifi-mac-queue-item.h"
 #include "wifi-mac-queue.h"
 #include "msdu-aggregator.h"
 #include "wifi-net-device.h"
-#include "ht-capabilities.h"
-#include "vht-capabilities.h"
-#include "he-capabilities.h"
-#include "wifi-mac.h"
+#include "ns3/ht-capabilities.h"
+#include "ns3/vht-capabilities.h"
+#include "ns3/he-capabilities.h"
+#include "regular-wifi-mac.h"
 #include "ctrl-headers.h"
 #include "wifi-mac-trailer.h"
+#include "wifi-tx-parameters.h"
 
 NS_LOG_COMPONENT_DEFINE ("MpduAggregator");
 
@@ -64,9 +64,17 @@
 }
 
 void
-MpduAggregator::SetEdcaQueues (EdcaQueues edcaQueues)
+MpduAggregator::DoDispose ()
 {
-    m_edca = edcaQueues;
+  m_mac = 0;
+  Object::DoDispose ();
+}
+
+void
+MpduAggregator::SetWifiMac (const Ptr<RegularWifiMac> mac)
+{
+  NS_LOG_FUNCTION (this << mac);
+  m_mac = mac;
 }
 
 void
@@ -116,11 +124,6 @@
   NS_LOG_FUNCTION (this << recipient << +tid << modulation);
 
   AcIndex ac = QosUtilsMapTidToAc (tid);
-  Ptr<QosTxop> qosTxop = m_edca.find (ac)->second;
-  Ptr<WifiNetDevice> device = DynamicCast<WifiNetDevice> (qosTxop->GetLow ()->GetPhy ()->GetDevice ());
-  NS_ASSERT (device);
-  Ptr<WifiRemoteStationManager> stationManager = device->GetRemoteStationManager ();
-  NS_ASSERT (stationManager);
 
   // Find the A-MPDU max size configured on this device
   UintegerValue size;
@@ -128,16 +131,16 @@
   switch (ac)
     {
       case AC_BE:
-        device->GetMac ()->GetAttribute ("BE_MaxAmpduSize", size);
+        m_mac->GetAttribute ("BE_MaxAmpduSize", size);
         break;
       case AC_BK:
-        device->GetMac ()->GetAttribute ("BK_MaxAmpduSize", size);
+        m_mac->GetAttribute ("BK_MaxAmpduSize", size);
         break;
       case AC_VI:
-        device->GetMac ()->GetAttribute ("VI_MaxAmpduSize", size);
+        m_mac->GetAttribute ("VI_MaxAmpduSize", size);
         break;
       case AC_VO:
-        device->GetMac ()->GetAttribute ("VO_MaxAmpduSize", size);
+        m_mac->GetAttribute ("VO_MaxAmpduSize", size);
         break;
       default:
         NS_ABORT_MSG ("Unknown AC " << ac);
@@ -152,6 +155,9 @@
       return 0;
     }
 
+  Ptr<WifiRemoteStationManager> stationManager = m_mac->GetWifiRemoteStationManager ();
+  NS_ASSERT (stationManager);
+
   // Retrieve the Capabilities elements advertised by the recipient
   Ptr<const HeCapabilities> heCapabilities = stationManager->GetStationHeCapabilities (recipient);
   Ptr<const VhtCapabilities> vhtCapabilities = stationManager->GetStationVhtCapabilities (recipient);
@@ -206,64 +212,33 @@
 }
 
 std::vector<Ptr<WifiMacQueueItem>>
-MpduAggregator::GetNextAmpdu (Ptr<const WifiMacQueueItem> mpdu, WifiTxVector txVector,
-                              Time ppduDurationLimit) const
+MpduAggregator::GetNextAmpdu (Ptr<WifiMacQueueItem> mpdu, WifiTxParameters& txParams,
+                              Time availableTime, WifiMacQueueItem::QueueIteratorPair queueIt) const
 {
-  NS_LOG_FUNCTION (this << *mpdu << ppduDurationLimit);
-  std::vector<Ptr<WifiMacQueueItem>> mpduList;
-  Mac48Address recipient = mpdu->GetHeader ().GetAddr1 ();
+  NS_LOG_FUNCTION (this << *mpdu << &txParams << availableTime);
 
-  NS_ASSERT (mpdu->GetHeader ().IsQosData () && !recipient.IsGroup ());
-
-  uint8_t tid = GetTid (mpdu->GetPacket (), mpdu->GetHeader ());
-  auto edcaIt = m_edca.find (QosUtilsMapTidToAc (tid));
-  NS_ASSERT (edcaIt != m_edca.end ());
+  std::vector<Ptr<WifiMacQueueItem>> mpduList;
 
-  WifiModulationClass modulation = txVector.GetMode ().GetModulationClass ();
-  uint32_t maxAmpduSize = GetMaxAmpduSize (recipient, tid, modulation);
+  Mac48Address recipient = mpdu->GetHeader ().GetAddr1 ();
+  NS_ASSERT (mpdu->GetHeader ().IsQosData () && !recipient.IsBroadcast ());
+  uint8_t tid = mpdu->GetHeader ().GetQosTid ();
 
-  if (maxAmpduSize == 0)
-    {
-      NS_LOG_DEBUG ("A-MPDU aggregation disabled");
-      return mpduList;
-    }
+  Ptr<QosTxop> qosTxop = m_mac->GetQosTxop (tid);
+  NS_ASSERT (qosTxop != 0);
 
-  //Have to make sure that the block ack agreement is established before sending an A-MPDU
-  if (edcaIt->second->GetBaAgreementEstablished (recipient, tid))
+  //Have to make sure that the block ack agreement is established and A-MPDU is enabled
+  if (qosTxop->GetBaAgreementEstablished (recipient, tid)
+      && GetMaxAmpduSize (recipient, tid, txParams.m_txVector.GetModulationClass ()) > 0)
     {
       /* here is performed MPDU aggregation */
-      uint16_t startingSequenceNumber = edcaIt->second->GetBaStartingSequence (recipient, tid);
-      Ptr<WifiMacQueueItem> nextMpdu;
-      uint16_t maxMpdus = edcaIt->second->GetBaBufferSize (recipient, tid);
-      uint32_t currentAmpduSize = 0;
-
-      // check if the received MPDU meets the size and duration constraints
-      if (edcaIt->second->GetLow ()->IsWithinSizeAndTimeLimits (mpdu, txVector, 0, ppduDurationLimit))
-        {
-          // MPDU can be aggregated
-          nextMpdu = Copy (mpdu);
-        }
+      Ptr<WifiMacQueueItem> nextMpdu = mpdu;
 
       while (nextMpdu != 0)
         {
-          /* if we are here, nextMpdu can be aggregated to the A-MPDU.
-           * nextMpdu may be any of the following:
-           * (a) an A-MSDU (with all the constituent MSDUs dequeued from
-           *     the EDCA queue)
-           * (b) an MSDU dequeued from the EDCA queue
-           * (c) a retransmitted MSDU or A-MSDU dequeued from the BA Manager queue
-           * (d) an MPDU that was aggregated in an A-MPDU which was not
-           *     transmitted (e.g., because the RTS/CTS exchange failed)
-           */
-
-          currentAmpduSize = GetSizeIfAggregated (nextMpdu->GetSize (), currentAmpduSize);
-
+          // if we are here, nextMpdu can be aggregated to the A-MPDU.
           NS_LOG_DEBUG ("Adding packet with sequence number " << nextMpdu->GetHeader ().GetSequenceNumber ()
                         << " to A-MPDU, packet size = " << nextMpdu->GetSize ()
-                        << ", A-MPDU size = " << currentAmpduSize);
-
-          // Always use the Normal Ack policy (Implicit Block Ack), for now
-          nextMpdu->GetHeader ().SetQosAckPolicy (WifiMacHeader::NORMAL_ACK);
+                        << ", A-MPDU size = " << txParams.GetSize (recipient));
 
           mpduList.push_back (nextMpdu);
 
@@ -271,28 +246,29 @@
           nextMpdu = 0;
 
           Ptr<const WifiMacQueueItem> peekedMpdu;
-          peekedMpdu = edcaIt->second->PeekNextFrame (tid, recipient);
+          peekedMpdu = qosTxop->PeekNextMpdu (queueIt, tid, recipient);
           if (peekedMpdu != 0)
             {
-              uint16_t currentSequenceNumber = peekedMpdu->GetHeader ().GetSequenceNumber ();
-
-              if (IsInWindow (currentSequenceNumber, startingSequenceNumber, maxMpdus))
-                {
-                  // dequeue the frame if constraints on size and duration limit are met.
-                  // Note that the dequeued MPDU differs from the peeked MPDU if A-MSDU
-                  // aggregation is performed during the dequeue
-                  NS_LOG_DEBUG ("Trying to aggregate another MPDU");
-                  nextMpdu = edcaIt->second->DequeuePeekedFrame (peekedMpdu, txVector, true,
-                                                                 currentAmpduSize, ppduDurationLimit);
-                }
+              // PeekNextMpdu() does not return an MPDU that is beyond the transmit window
+              NS_ASSERT (IsInWindow (peekedMpdu->GetHeader ().GetSequenceNumber (),
+                                     qosTxop->GetBaStartingSequence (recipient, tid),
+                                     qosTxop->GetBaBufferSize (recipient, tid)));
+
+              // get the next MPDU to aggregate, provided that the constraints on size
+              // and duration limit are met. Note that the returned MPDU differs from
+              // the peeked MPDU if A-MSDU aggregation is enabled.
+              NS_LOG_DEBUG ("Trying to aggregate another MPDU");
+              nextMpdu = qosTxop->GetNextMpdu (peekedMpdu, txParams, availableTime, false, queueIt);
             }
         }
+
       if (mpduList.size () == 1)
         {
           // return an empty vector if it was not possible to aggregate at least two MPDUs
           mpduList.clear ();
         }
     }
+
   return mpduList;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/mpdu-aggregator.h ns-3.34/src/wifi/model/mpdu-aggregator.h
--- ns-3.33/src/wifi/model/mpdu-aggregator.h	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/mpdu-aggregator.h	2021-07-14 10:31:07.000000000 -0700
@@ -33,6 +33,8 @@
 class WifiTxVector;
 class Packet;
 class WifiMacQueueItem;
+class RegularWifiMac;
+class WifiTxParameters;
 
 /**
  * \brief Aggregator used to construct A-MPDUs
@@ -95,9 +97,12 @@
    * as determined for the modulation class indicated by the given TxVector
    *
    * - the time to transmit the resulting PPDU, according to the given TxVector,
-   * does not exceed both the maximum PPDU duration allowed by the corresponding
-   * modulation class (if any) and the given PPDU duration limit (if distinct from
-   * Time::Min ())
+   * does not exceed the maximum PPDU duration allowed by the corresponding
+   * modulation class (if any)
+   *
+   * - the time to transmit the resulting PPDU and to carry out protection and
+   * acknowledgment, as specified by the given TX parameters, does not exceed the
+   * given available time (if distinct from Time::Min ())
    *
    * For now, only non-broadcast QoS Data frames can be aggregated (do not pass
    * other types of frames to this method). MPDUs to aggregate are looked for
@@ -111,20 +116,23 @@
    * the returned vector is empty.
    *
    * \param mpdu the given MPDU.
-   * \param txVector the TxVector used to transmit the frame
-   * \param ppduDurationLimit the limit on the PPDU duration
+   * \param txParams the TX parameters used to transmit the frame
+   * \param availableTime the time available for the frame exchange
+   * \param queueIt the QueueIteratorPair pointing to the queue item from which the
+   *                search for an MPDU starts, if the QueueIteratorPair is valid
    * \return the resulting A-MPDU, if aggregation is possible.
    */
-  std::vector<Ptr<WifiMacQueueItem>> GetNextAmpdu (Ptr<const WifiMacQueueItem> mpdu,
-                                                   WifiTxVector txVector,
-                                                   Time ppduDurationLimit = Time::Min ()) const;
+  std::vector<Ptr<WifiMacQueueItem>> GetNextAmpdu (Ptr<WifiMacQueueItem> mpdu,
+                                                   WifiTxParameters& txParams,
+                                                   Time availableTime,
+                                                   WifiMacQueueItem::QueueIteratorPair queueIt) const;
 
   /**
-   * Set the map of EDCA queues.
+   * Set the MAC layer to use.
    *
-   * \param edcaQueues the map of EDCA queues.
+   * \param mac the MAC layer to use
    */
-  void SetEdcaQueues (EdcaQueues edcaQueues);
+  void SetWifiMac (const Ptr<RegularWifiMac> mac);
 
   /**
    * \param ampduSize the size of the A-MPDU that needs to be padded in bytes
@@ -142,11 +150,15 @@
    *
    * \param mpduSize size of the MPDU in bytes.
    * \param isSingle true if S-MPDU.
+   * \return the A-MPDU subframe header
    */
   static AmpduSubframeHeader GetAmpduSubframeHeader (uint16_t mpduSize, bool isSingle);
 
+protected:
+  void DoDispose () override;
+
 private:
-  EdcaQueues m_edca;   //!< the map of EDCA queues
+  Ptr<RegularWifiMac> m_mac;   //!< the MAC of this station
 };
 
 }  //namespace ns3
